Imports System
Imports System.IO
Imports System.Net.Sockets
Imports System.Text

Imports Vajhoej.Record

Namespace Vajhoej.VMS.TIG
	Public Class Connection
		Private tc As TcpClient
		Private ms As MemoryStream
		Private bw As BinaryWriter
		Private br As BinaryReader
		Public Sub New(tc As TcpClient)
			Me.tc = tc
		End Sub
		Public Sub Prep()
			ms = New MemoryStream()
			bw = New BinaryWriter(ms)
			bw.Write(0)
			' length to be updated later 
		End Sub
		Public Sub PutByte(v As Byte)
			bw.Write(v)
		End Sub
		Public Sub PutShort(v As Short)
			bw.Write(v)
		End Sub
		Public Sub PutInteger(v As Integer)
			bw.Write(v)
		End Sub
		Public Sub PutLong(v As Long)
			bw.Write(v)
		End Sub
		Public Sub PutSingle(v As Single)
			bw.Write(v)
		End Sub
		Public Sub PutDouble(v As Double)
			bw.Write(v)
		End Sub
		Public Sub PutString(v As String)
			Dim temp As Byte() = Encoding.GetEncoding(1252).GetBytes(v)
			bw.Write(CShort(temp.Length))
			bw.Write(temp)
		End Sub
		Public Sub PutBytes(v As Byte())
			bw.Write(CShort(v.Length))
			bw.Write(v)
		End Sub
		Public Sub PutBlock(o As [Object])
			Dim sw As New StructWriter()
			sw.Write(o)
			Dim temp As Byte() = sw.GetBytes()
			PutBytes(temp)
		End Sub
		Public Sub Send()
			Dim wrlen As Integer = CInt(ms.Length) - 4
			bw.Seek(0, SeekOrigin.Begin)
			bw.Write(wrlen)
			' update length
			tc.GetStream().Write(ms.GetBuffer(), 0, wrlen + 4)
			tc.GetStream().Flush()
		End Sub
		Public Sub Recv()
			br = New BinaryReader(tc.GetStream())
			Dim frlen As Integer = br.ReadInt32()
			Dim fr As Byte() = br.ReadBytes(frlen)
			ms = New MemoryStream(fr)
			br = New BinaryReader(ms)
		End Sub
		Public Function GetByte() As Byte
			Return br.ReadByte()
		End Function
		Public Function GetShort() As Short
			Return br.ReadInt16()
		End Function
		Public Function GetInteger() As Integer
			Return br.ReadInt32()
		End Function
		Public Function GetLong() As Long
			Return br.ReadInt64()
		End Function
		Public Function GetSingle() As Single
			Return br.ReadSingle()
		End Function
		Public Function GetDouble() As Double
			Return br.ReadDouble()
		End Function
		Public Function GetString() As String
			Dim len As Integer = br.ReadInt16()
			Dim temp As Byte() = br.ReadBytes(len)
			Return Encoding.GetEncoding(1252).GetString(temp)
		End Function
		Public Function GetBytes() As Byte()
			Dim len As Integer = br.ReadInt16()
			Dim temp As Byte() = br.ReadBytes(len)
			Return temp
		End Function
		Public Function GetBlock(Of T As {Class, New})(t2 As Type) As T
			Dim temp As Byte() = GetBytes()
			Dim sr As New StructReader(temp)
			Return sr.Read(Of T)(t2)
		End Function
		Public Sub GetBlock(Of T As {Class, New})(o As T)
			Dim temp As Byte() = GetBytes()
			Dim sr As New StructReader(temp)
			sr.Read(o)
		End Sub
		Public Sub Close()
			bw.Close()
			br.Close()
		End Sub
	End Class
End Namespace
