<?php

class Connection {
    private $s;
    private $buf;
    private $bufix;
    function __construct($host, $port) {
        $this->s = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
        socket_connect($this->s, $host, $port);
    }
    function prep() {
        $this->buf = '';
    }
    function put_int16($v) {
        $this->buf .= pack('v', $v);
    }
    function put_int32($v) {
        $this->buf .= pack('V', $v);
    }
    function put_int64($v) {
        $this->buf .= pack('p', $v);
    }
    function put_float($v) {
        $this->buf .= pack('g', $v);
    }
    function put_double($v) {
        $this->buf .= pack('e', $v);
    }
    function put_string($v) {
        $vlen = strlen($v);
        $this->put_int16($vlen);
        $this->buf .= pack("a$vlen", $v);
    }
    function put_bytes($v) {
        $vlen = strlen($v);
        $this->put_int16($vlen);
        $this->buf .= pack("a$vlen", $v);
    }
    function put_block($v) {
        $temp = $v->pack();
        $this->put_bytes($temp);
    }
    function send() {
        $wrlen = strlen($this->buf);
        $this->buf = pack('V', $wrlen) . $this->buf;
        socket_send($this->s, $this->buf, 4 + $wrlen, 0);
    }
    function recv() {
        $temp = '';
        socket_recv($this->s, $temp, 4, 0);
        $rdlen = unpack('V', $temp)[1];
        $this->buf = '';
        socket_recv($this->s, $this->buf, $rdlen, 0);
        $this->bufix = 0;
    }
    function get_int16() {
        $v = unpack('v', $this->buf, $this->bufix)[1];
        $this->bufix += 2;
        return $v;
    }
    function get_int32() {
        $v = unpack('V', $this->buf, $this->bufix)[1];
        $this->bufix += 4;
        return $v;
    }
    function get_int64() {
        $v = unpack('p', $this->buf, $this->bufix)[1];
        $this->bufix += 8;
        return $v;
    }
    function get_float() {
        $v = unpack('g', $this->buf, $this->bufix)[1];
        $this->bufix += 4;
        return $v;
    }
    function get_double() {
        $v = unpack('e', $this->buf, $this->bufix)[1];
        $this->bufix += 4;
        return $v;
    }
    function get_string() {
        $vlen = unpack('v', $this->buf, $this->bufix)[1];
        $this->bufix += 2;
        $v = unpack("a$vlen", $this->buf, $this->bufix)[1];
        $this->bufix += $vlen;
        return $v;
    }
    function get_bytes() {
        $vlen = unpack('v', $this->buf, $this->bufix)[1];
        $this->bufix += 2;
        $v = unpack("a$vlen", $this->buf, $this->bufix)[1];
        $this->bufix += $vlen;
        return $v;
    }
    function get_block(&$o) {
        $temp = $this->get_bytes();
        $o->unpack($temp);
    }
    function close() {
        socket_close($this->s);
    }
}

?>
